#!/bin/sh

# arguments
# 1: path to old version of application, not including the name
# 2: name of old application
# 3: pid of running application
# 4: path to dmg file
# 5: version of installed application

# a few sanity checks
#if [ -z $1 ]; then exit 1; fi
#if [ -z $2 ]; then exit 1; fi
#if [ -z $3 ]; then exit 1; fi
#if [ -z $4 ]; then exit 1; fi
#if [ -z $5 ]; then exit 1; fi
echo "running install script"

# step 1: force unmount image
/usr/bin/hdiutil detach -force "/Volumes/SyniumTemp"

# step 2: mount the image
if ! /usr/bin/hdiutil mount -private -nobrowse -mountpoint "/Volumes/SyniumTemp" "$4"
then
	# restart the old application
	/bin/kill -HUP $3
	/usr/bin/open "$1/$2"
	exit 1
fi

# step 3: delete old version of application

if ! /bin/rm -rf "$1/$2"
then
	# unmount image
	/usr/bin/hdiutil detach "/Volumes/SyniumTemp"
	# restart the old application
	/bin/kill -HUP $3
	/usr/bin/open "$1/$2"
	exit 1
fi

# step 4: move new version to old place
# this is being done by a script on the dmg itself

NEW_APP_PATH=""
. "/Volumes/SyniumTemp/.appinstall.sh" "$1" $5
if [ -z "$NEW_APP_PATH" ];
then
	# for compatibilty's sake, just pretend the old version was the new one
	NEW_APP_PATH="$1/$2"
fi


# step 5: detach image
/usr/bin/hdiutil detach "/Volumes/SyniumTemp"

# step 6: remove image
/bin/rm "$4"

# step 7: kill old application
/bin/kill -HUP $3

# step 8: launch new version
/usr/bin/open "$NEW_APP_PATH"
