//
//  GeometryUtilities.h
//  MacFamilyTree
//
//  Created by Mendel Kucharzeck on 23.02.10.
//  Copyright 2010 w. All rights reserved.
//




@interface GeometryUtilities : NSObject
{
}

+ (float) angleOfRay:(CGPoint)ray; //Returns Radians

+ (float) distanceOfPoint:(CGPoint)point toLineOrigin:(CGPoint)origin absoluteDestination:(CGPoint)destination;

+ (CGPoint) nearestPointInArray:(NSArray*)points fromPoint:(CGPoint)point;
+ (float) distanceOfPoint:(CGPoint)point1 toPoint:(CGPoint)point2;

+ (CGPoint) intersectLineStartPoint:(CGPoint)StartPoint1 endPoint:(CGPoint)EndPoint1 withLineStartPoint:(CGPoint)StartPoint2 endPoint:(CGPoint)EndPoint2;

+ (float) length:(CGPoint)vector;
+ (CGPoint) normalize:(CGPoint)vector;
+ (CGPoint) scaleVector:(CGPoint)vector by:(float)scale;
+ (CGPoint) multipyVector:(CGPoint)vector1 withVector:(CGPoint)vector2;
+ (CGPoint) addVector:(CGPoint)vector1 toVector:(CGPoint)vector2;

+ (CGPoint) flipBy90Degrees:(CGPoint)vector;

+ (CGRect) centerRect:(CGRect)rect inRect:(CGRect)bounds;
+ (CGRect) scaledRectInBounds:(CGRect)bounds size:(CGSize)size;
+ (CGRect) fittedRectInBounds:(CGRect)bounds size:(CGSize)size;
+ (CGSize) proportionallyScaleSize:(CGSize)size toFitInSize:(CGSize)bounds;

+ (CGRect) boundsOfPoints:(NSArray*)points;

+ (CGPoint) rotatePoint:(CGPoint)rotatePoint aroundPoint:(CGPoint)originPoint withDegrees:(double)degrees;

+ (CGPoint) findNearestPointOnRectangle:(CGRect)rect forPoint:(CGPoint)point;

+ (CGRect) scaleRect:(CGRect)rect byFactor:(float)factor;
+ (CGRect) roundRect:(CGRect)rect;


@end
