//
//  NSDate-Addtitions.h
//  Diary
//
//  Created by Robert Fujara on 19.03.09.
//  Copyright 2009 Synium Software GmbH. All rights reserved.
//

@interface NSDate (NSDateAdditions)

+ (NSTimeZone*) updateSystemTimeZone;

#ifdef DEBUG

+ (void) setDate:(NSDate*)date;

#endif

+ (NSDate*) currentDiaryDate;

+ (NSDate*) currentDiaryDateWithZeroTime;

+ (NSTimeZone*) systemTimeZone;

- (NSDate*) diaryDate;

- (NSDate*) systemDate;

- (NSDate*) dateWithZeroTime;

- (int) dayOfWeek;

- (int) monthOfYear;

- (int) dayOfMonth;

- (NSDate*) dateByAddingYears:(NSInteger)year months:(NSInteger)month days:(NSInteger)day;

- (NSDate*) dateByAddingHours:(NSInteger)hours;

- (int) yearOfCommonEra;

+ (id) dateWithYear:(NSInteger)year month:(NSUInteger)month day:(NSUInteger)day;

+ (NSCalendar*) calendar;

- (NSDate*) dateByAddingTimeInterval:(NSTimeInterval)interval;

+ (id) currentDiaryDateWithHour:(NSInteger)hour minute:(NSUInteger)minute second:(NSUInteger)second;

@end
