//
//  NSManagedObjectContext-Additions.h
//  Diary
//
//  Created by Robert Fujara on 06.05.09.
//  Copyright 2009 Synium Software GmbH. All rights reserved.
//

@interface NSManagedObjectContext (Additions)

- (NSArray*) fetchObjects:(Class)managedObjectClass
		   usingPredicate:(NSPredicate*)predicate;

- (NSArray*) fetchObjects:(Class)managedObjectClass
		   usingPredicate:(NSPredicate*)predicate
				  idsOnly:(BOOL)idsOnly;

- (NSManagedObject*) fetchObject:(Class)managedObjectClass
				  usingPredicate:(NSPredicate*)predicate;

- (NSManagedObject*) fetchObject:(Class)managedObjectClass
				  usingPredicate:(NSPredicate*)predicate
						 idsOnly:(BOOL)idsOnly;

- (BOOL) save;

- (BOOL) saveAndRollbackOnError;

- (NSManagedObject *)objectWithURI:(NSURL *)uri;

- (NSManagedObject *)objectWithObjectID:(NSManagedObjectID *)objectID;

@end
